﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _238957
{
    public partial class Form1 : Form
    {
        private List<Model> dataSource = new List<Model>();
        Random rnd = new Random();

        public Form1()
        {
            InitializeComponent();
            for (int i = 0; i < 5; i++)
            {
                this.dataSource.Add(new Model(rnd.Next(100)));
            }

            radGridView1.DataSource = dataSource;
          
            this.radGridView1.EditorRequired += radGridView1_EditorRequired;
            this.radGridView1.CellFormatting += radGridView1_CellFormatting;
        }

        List<string> GetListDataSource()
        {
            List<string> data = new List<string>();
            data.Add("one");
            data.Add("two");
            data.Add("three");
            data.Add("four");
            data.Add("five");
            data.Add("six");
            data.Add("seven");
            data.Add("zero");
            
            return data;
        }

        void radGridView1_CellFormatting(object sender, CellFormattingEventArgs e)
        {
            if (e.Column.Name == "ID" && e.CellElement.Value != null)
            {
                //optionally you can display text in all cells
                //e.CellElement.Text = GridViewCheckedDropDownListEditor.DigitToNum((int)e.CellElement.Value);
            }
        }

        void radGridView1_EditorRequired(object sender, EditorRequiredEventArgs e)
        {
            if (this.radGridView1.CurrentColumn.Index == 0)
            {
                RadCheckedDropDownListElement editor = new GridViewCheckedDropDownListEditor();
                editor.DataSource = GetListDataSource();
              
                e.Editor = editor;
            }
        }
    }

    public class GridViewCheckedDropDownListEditor : RadCheckedDropDownListElement
    {
        public override object Value
        {
            get
            {
                return GetValue(this.Text);
            }
            set
            {
                this.Text = DigitToNum((int)value);
            }
        }
        
        public int GetValue(string value)
        {
            string[] temp = value.Split(';');
            string text = "";
            if (temp.Length > 0)
            {
                for (int i = 0; i < temp.Length; i++)
                {
                    text += NumToDigit(temp[i]);
                }
            }
            else
            {
                text = NumToDigit(value);
            }
            return Convert.ToInt32(text);
        }

        public static string DigitToNum(int value)
        {
            string text = "";
            foreach (char ch in value.ToString())
            {
                switch (ch)
                {
                    case '1':
                        text += "one;";
                        break;
                    case '2':
                        text += "two;";
                        break;
                    case '3':
                        text += "three;";
                        break;
                    case '4':
                        text += "four;";
                        break;
                    case '5':
                        text += "five;";
                        break;
                    case '6':
                        text += "six;";
                        break;
                    case '7':
                        text += "seven;";
                        break;
                    case '8':
                        text += "eight;";
                        break;
                    case '9':
                        text += "nine;";
                        break;
                    case '0':
                        text += "zero;";
                        break;
                }
            }
            return text;
        }

        public static string NumToDigit(string num)
        { 
            string text = "";
            switch (num)
            {
                case "one":
                    text += "1";
                    break;
                case "two":
                    text += "2";
                    break;
                case "three":
                    text += "3";
                    break;
                case "four":
                    text += "4";
                    break;
                case "five":
                    text += "5";
                    break;
                case "six":
                    text += "6";
                    break;
                case "seven":
                    text += "7";
                    break;
                case "eight":
                    text += "8";
                    break;
                case "nine":
                    text += "0";
                    break;
                case "zero":
                    text += "0";
                    break;
            }
            return text;
        }
    }

    public class Model
    {
        public Model(int ID)
        {
            this.ID = ID;
        }

        public int ID { get; set; }
    }
}